<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__capsense__tuner_8c" kind="file" language="C++">
    <compoundname>cy_capsense_tuner.c</compoundname>
    <includes local="no">stddef.h</includes>
    <includes local="yes">cy_syslib.h</includes>
    <includes local="yes" refid="cy__capsense__structure_8h">cy_capsense_structure.h</includes>
    <includes local="yes" refid="cy__capsense__tuner_8h">cy_capsense_tuner.h</includes>
    <includes local="yes" refid="cy__capsense__control_8h">cy_capsense_control.h</includes>
    <includes local="yes" refid="cy__capsense__common_8h">cy_capsense_common.h</includes>
    <incdepgraph>
      <node id="119">
        <label>cy_syslib.h</label>
      </node>
      <node id="118">
        <label>stddef.h</label>
      </node>
      <node id="117">
        <label>cy_capsense_tuner.c</label>
        <link refid="cy__capsense__tuner_8c" />
        <childnode refid="118" relation="include">
        </childnode>
        <childnode refid="119" relation="include">
        </childnode>
      </node>
    </incdepgraph>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="cy__capsense__tuner_8c_1a9fbb5e9a649e7344ca647673b2afd071" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_CapSense_TuInitialize</definition>
        <argsstring>(cy_stc_capsense_context_t *context)</argsstring>
        <name>Cy_CapSense_TuInitialize</name>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__capsense__context__t">cy_stc_capsense_context_t</ref> *</type>
          <declname>context</declname>
        </param>
        <briefdescription>
<para>Initializes the communication interface with the CapSense Tuner tool. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="39" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-capsense/cy_capsense_tuner.c" bodystart="34" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-capsense/cy_capsense_tuner.c" line="34" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__capsense__high__level_1ga0c613df550388c119fdab4e50341a6b4" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t Cy_CapSense_RunTuner</definition>
        <argsstring>(cy_stc_capsense_context_t *context)</argsstring>
        <name>Cy_CapSense_RunTuner</name>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__capsense__context__t">cy_stc_capsense_context_t</ref> *</type>
          <declname>context</declname>
        </param>
        <briefdescription>
<para>Establishes synchronized operation between the CapSense Middleware and the CapSense Tuner tool. </para>        </briefdescription>
        <detaileddescription>
<para>This function is called periodically in the application program. It serves the CapSense Tuner tool requests and commands to synchronize the operation. Mostly, the best place to call this function is between processing and next scanning. If the user changes some parameters in the Tuner tool, the middleware is re-started - the Tuner issues a restart command to be executed by this function.</para><para>The Tuner interface supports two communication protocol: EZI2C and UART.</para><para>To use an EZI2C-based tuner interface, only initialization of the EZI2C driver and interface is required in the application program. Refer to the I2C driver documentation for details of the protocol implementation and data package format by the EZI2C interface.</para><para>To use a UART-based tuner interface, the user must:<itemizedlist>
<listitem><para>Initialize the UART driver and interface</para></listitem><listitem><para>Use a callback function to facilitate data transmission and reception using the UART driver.</para></listitem></itemizedlist>
</para><para>The application program must:<itemizedlist>
<listitem><para>Form a transmission data packet</para></listitem><listitem><para>Validate the data package on receiver implementation prior to passing to the CapSense Middleware.</para></listitem></itemizedlist>
</para><para>The transmission packet includes a CapSense context structure sandwiched between a header (0x0D0A) and a tail (0x00FFFF), hence the package size is dependent on CapSense context information. The receiver packet is 16-byte (fixed length) data explained under the <ref kindref="member" refid="group__group__capsense__high__level_1ga1f0fdedcec1ad936f5e9e4ae28f17274">Cy_CapSense_CheckTunerCmdIntegrity()</ref> function. The <ref kindref="member" refid="group__group__capsense__high__level_1ga1f0fdedcec1ad936f5e9e4ae28f17274">Cy_CapSense_CheckTunerCmdIntegrity()</ref> function is used to validate the received data package prior to passing it to the CapSense middleware.</para><para>Periodical calling the <ref kindref="member" refid="group__group__capsense__high__level_1ga0c613df550388c119fdab4e50341a6b4">Cy_CapSense_RunTuner()</ref> function is:<itemizedlist>
<listitem><para>mandatory for operation of a UART-based tuner interface. The middleware operation is always synchronous to the Tuner tool.</para></listitem><listitem><para>optional to periodically call <ref kindref="member" refid="group__group__capsense__high__level_1ga0c613df550388c119fdab4e50341a6b4">Cy_CapSense_RunTuner()</ref> for EZI2C based interface.</para></listitem></itemizedlist>
</para><para>If the <ref kindref="member" refid="group__group__capsense__high__level_1ga0c613df550388c119fdab4e50341a6b4">Cy_CapSense_RunTuner()</ref> function is not periodically called by the application program, the middleware operation is asynchronous to the Tuner tool and the following disadvantages are applicable:<itemizedlist>
<listitem><para>The raw counts displayed in the CapSense Tuner tool may be filtered and/or non-filtered. Result – noise and SNR measurements are not accurate.</para></listitem><listitem><para>The CapSense Tuner tool can read sensor data (such as raw counts) from a scan multiply. Result – noise and SNR measurement are not accurate.</para></listitem><listitem><para>The CapSense Tuner tool and Host controller should not change the parameters via the Tuner interface – in async mode this leads to abnormal behavior.</para></listitem><listitem><para>Displaying detected gestures may be missed.</para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;This function executes received commands. Two commands CY_CAPSENSE_TU_CMD_ONE_SCAN_E and CY_CAPSENSE_TU_CMD_SUSPEND_E change the FW tuner module state to suspend. In this state, the function waits until CY_CAPSENSE_TU_CMD_RESUME_E is received. Use a callback mechanism of command receiving to avoid FW hanging. Refer to the Function Usage section for examples.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>context</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CapSense context structure <ref kindref="compound" refid="structcy__stc__capsense__context__t">cy_stc_capsense_context_t</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The return parameter indicates whether a middleware re-start was executed by this function or not:<itemizedlist>
<listitem><para>CY_CAPSENSE_STATUS_RESTART_DONE - Based on a received command, the CapSense was re-initialized.</para></listitem><listitem><para>CY_CAPSENSE_STATUS_RESTART_NONE - Re-start was not executed by this function.</para></listitem></itemizedlist>
</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para /></simplesect>
An example of synchronization with the Tuner tool using EzI2C: <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />EZI2C<sp />Initialization<sp />and<sp />assignment<sp />of<sp />communication<sp />buffer<sp />to<sp />cy_capsense_tuner<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SCB_EZI2C_Init(EZI2C_HW,<sp />&amp;EZI2C_config,<sp />&amp;EZI2C_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysInt_Init(&amp;EZI2C_ISR_cfg,<sp />&amp;EZI2C_Interrupt);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_EnableIRQ(EZI2C_ISR_cfg.intrSrc);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SCB_EZI2C_SetBuffer1(EZI2C_HW,<sp />(uint8<sp />*)&amp;cy_capsense_tuner,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(cy_capsense_tuner),<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(cy_capsense_tuner),<sp />&amp;EZI2C_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SCB_EZI2C_Enable(EZI2C_HW);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__capsense__macros__general_1ga1bd45eed2be393b7f53c20f1bae2814e">CY_CAPSENSE_NOT_BUSY</ref><sp />==<sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga7f8739755bba6b51c274f45b569b9ba0">Cy_CapSense_IsBusy</ref>(&amp;cy_capsense_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga2a185db228d5cae975fbc92bd3bc6367">Cy_CapSense_ProcessAllWidgets</ref>(&amp;cy_capsense_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga0c613df550388c119fdab4e50341a6b4">Cy_CapSense_RunTuner</ref>(&amp;cy_capsense_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga50e6ef42f2834083715abe86d8a85b48">Cy_CapSense_ScanAllWidgets</ref>(&amp;cy_capsense_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> An example of synchronization with the Tuner tool using UART.<linebreak />
 Tuner Send callback implementation: Transmitting data through UART interface: <programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />TunerSend(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*<sp />context)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />uartTxHeader[]<sp />=<sp />{0x0Du,<sp />0x0Au};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />uartTxTail[]<sp />=<sp />{0x00u,<sp />0xFFu,<sp />0xFFu};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)context;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SCB_UART_PutArrayBlocking(UART_HW,<sp />&amp;(uartTxHeader[0u]),<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(uartTxHeader));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SCB_UART_PutArrayBlocking(UART_HW,<sp />(uint8<sp />*)&amp;cy_capsense_tuner,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(cy_capsense_tuner));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SCB_UART_PutArrayBlocking(UART_HW,<sp />uartTxTail,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(uartTxTail));</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> Tuner Receive callback implementation: Receiving data from UART interface: <programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />TunerReceive(uint8_t<sp />**<sp />packet,<sp />uint8_t<sp />**<sp />tunerPacket,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*<sp />context)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />i;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp />context;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint32_t<sp />dataIndex<sp />=<sp />0u;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint8_t<sp />commandPacket[16u]<sp />=<sp />{0u};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(0<sp />!=<sp />Cy_SCB_UART_GetNumInRxFifo(UART_HW))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />commandPacket[dataIndex++]<sp />=<sp />(uint8_t)Cy_SCB_UART_Get(UART_HW);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_CAPSENSE_COMMAND_PACKET_SIZE<sp />&lt;=<sp />dataIndex)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_CAPSENSE_COMMAND_OK<sp />==<sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga1f0fdedcec1ad936f5e9e4ae28f17274">Cy_CapSense_CheckTunerCmdIntegrity</ref>(&amp;commandPacket[0u]))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Found<sp />a<sp />correct<sp />command,<sp />reset<sp />data<sp />index<sp />and<sp />assign<sp />pointers<sp />to<sp />buffers<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dataIndex<sp />=<sp />0u;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*tunerPacket<sp />=<sp />(uint8_t<sp />*)&amp;cy_capsense_tuner;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*packet<sp />=<sp />&amp;commandPacket[0u];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Command<sp />is<sp />not<sp />correct,<sp />remove<sp />the<sp />first<sp />byte<sp />in<sp />commandPacket<sp />FIFO<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dataIndex--;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(i<sp />=<sp />0u;<sp />i<sp />&lt;<sp />(CY_CAPSENSE_COMMAND_PACKET_SIZE<sp />-<sp />1u);<sp />i++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />commandPacket[i]<sp />=<sp />commandPacket[i<sp />+<sp />1u];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> A part of the main.c FW flow with registering callbacks: <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*...*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />communication<sp />callbacks<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cy_capsense_context.ptrCommonContext-&gt;ptrTunerSendCallback<sp />=<sp />TunerSend;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cy_capsense_context.ptrCommonContext-&gt;ptrTunerReceiveCallback<sp />=<sp />TunerReceive;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SCB_UART_Init(UART_HW,<sp />&amp;UART_config,<sp />&amp;UART_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SCB_UART_Enable(UART_HW);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__capsense__macros__general_1ga1bd45eed2be393b7f53c20f1bae2814e">CY_CAPSENSE_NOT_BUSY</ref><sp />==<sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga7f8739755bba6b51c274f45b569b9ba0">Cy_CapSense_IsBusy</ref>(&amp;cy_capsense_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga2a185db228d5cae975fbc92bd3bc6367">Cy_CapSense_ProcessAllWidgets</ref>(&amp;cy_capsense_context);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Cy_CapSense_RunTuner()<sp />calls<sp />periodically<sp />communication<sp />callbacks</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />for<sp />hence<sp />the<sp />Tuner<sp />tool<sp />are<sp />able<sp />to<sp />monitor<sp />sensor<sp />signals/statuses</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />and<sp />change<sp />CapSense<sp />parameters<sp />for<sp />easy<sp />tuning.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga0c613df550388c119fdab4e50341a6b4">Cy_CapSense_RunTuner</ref>(&amp;cy_capsense_context);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga50e6ef42f2834083715abe86d8a85b48">Cy_CapSense_ScanAllWidgets</ref>(&amp;cy_capsense_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*...*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> Refer to the <ref kindref="compound" refid="group__group__capsense__callbacks">Callbacks</ref> section for details. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="281" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-capsense/cy_capsense_tuner.c" bodystart="137" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-capsense/cy_capsense_tuner.c" line="137" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__capsense__high__level_1ga1f0fdedcec1ad936f5e9e4ae28f17274" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t Cy_CapSense_CheckTunerCmdIntegrity</definition>
        <argsstring>(const uint8_t *commandPacket)</argsstring>
        <name>Cy_CapSense_CheckTunerCmdIntegrity</name>
        <param>
          <type>const uint8_t *</type>
          <declname>commandPacket</declname>
        </param>
        <briefdescription>
<para>Checks command format, header, tail, CRC, etc. </para>        </briefdescription>
        <detaileddescription>
<para>This function checks whether the specified packet with the size CY_CAPSENSE_COMMAND_PACKET_SIZE could be represented as a command received from the CapSense Tuner tool. The verification includes the following items:<itemizedlist>
<listitem><para>Header</para></listitem><listitem><para>Tail</para></listitem><listitem><para>CRC</para></listitem><listitem><para>Command code</para></listitem></itemizedlist>
</para><para>Command format is the following:<itemizedlist>
<listitem><para>Byte 0: Header 0 = 0x0D</para></listitem><listitem><para>Byte 1: Header 1 = 0x0A</para></listitem><listitem><para>Byte 2: Command code = cy_en_capsense_tuner_cmd_t</para></listitem><listitem><para>Byte 3: Command counter</para></listitem><listitem><para>Byte 4: Size = either 1, 2 or 4</para></listitem><listitem><para>Byte 5: Offset MSB</para></listitem><listitem><para>Byte 6: Offset LSB</para></listitem><listitem><para>Byte 7: Data MSB</para></listitem><listitem><para>Byte 8: Data</para></listitem><listitem><para>Byte 9: Data</para></listitem><listitem><para>Byte 10: Data LSB</para></listitem><listitem><para>Byte 11: 16-bit CRC MSB</para></listitem><listitem><para>Byte 12: 16-bit CRC LSB</para></listitem><listitem><para>Byte 13: Tail 0 = 0x00</para></listitem><listitem><para>Byte 14: Tail 1 = 0xFF</para></listitem><listitem><para>Byte 15: Tail 2 = 0xFF</para></listitem></itemizedlist>
</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>commandPacket</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the data packet that should be verified.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Returns the result of the command verification:<itemizedlist>
<listitem><para>CY_CAPSENSE_COMMAND_OK - Command is correct.</para></listitem><listitem><para>CY_CAPSENSE_WRONG_HEADER - Wrong header.</para></listitem><listitem><para>CY_CAPSENSE_WRONG_TAIL - Wrong tail.</para></listitem><listitem><para>CY_CAPSENSE_WRONG_CRC - Wrong CRC.</para></listitem><listitem><para>CY_CAPSENSE_WRONG_CODE - Wrong Command code. </para></listitem></itemizedlist>
</para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="369" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-capsense/cy_capsense_tuner.c" bodystart="329" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-capsense/cy_capsense_tuner.c" line="329" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>This file provides the source code for the Tuner module functions. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="version"><para>3.0</para></simplesect>
<simplesect kind="copyright"><para>Copyright 2018-2020, Cypress Semiconductor Corporation. All rights reserved. You may use this file only in accordance with the license, terms, conditions, disclaimers, and limitations in the end user license agreement accompanying the software package with which this file was provided. </para></simplesect>
</para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="17"><highlight class="preprocessor">#include<sp />&lt;stddef.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="18"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_syslib.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="19"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_capsense_structure.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="20"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_capsense_tuner.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="21"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_capsense_control.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="22"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_capsense_common.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="23"><highlight class="normal" /></codeline>
<codeline lineno="24"><highlight class="normal" /><highlight class="preprocessor">#if<sp />(defined(CY_IP_MXCSDV2)<sp />||<sp />defined(CY_IP_M0S8CSDV2)<sp />||<sp />defined(CY_IP_M0S8MSCV3))</highlight><highlight class="normal" /></codeline>
<codeline lineno="25"><highlight class="normal" /></codeline>
<codeline lineno="26"><highlight class="normal" /></codeline>
<codeline lineno="27"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="28"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_CapSense_TuInitialize</highlight></codeline>
<codeline lineno="29"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="34"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_CapSense_TuInitialize(<ref kindref="compound" refid="structcy__stc__capsense__context__t">cy_stc_capsense_context_t</ref><sp />*<sp />context)</highlight></codeline>
<codeline lineno="35"><highlight class="normal">{</highlight></codeline>
<codeline lineno="36"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">volatile</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__capsense__common__context__t">cy_stc_capsense_common_context_t</ref><sp />*<sp />ptrCommonCxt<sp />=<sp />context-&gt;<ref kindref="member" refid="structcy__stc__capsense__context__t_1a2f4f7d25d0816cf7fe6f04103c4d647e">ptrCommonContext</ref>;</highlight></codeline>
<codeline lineno="37"><highlight class="normal"><sp /><sp /><sp /><sp />ptrCommonCxt-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1afae9853b830d6549b35bafc214acc040">tunerCmd</ref><sp />=<sp />(uint16_t)<ref kindref="member" refid="group__group__capsense__enums_1gga049118d05a2bdf4f2d37d7b75c511f79a3fdf6f04116abcaf626fda9269e9dba8">CY_CAPSENSE_TU_CMD_NONE_E</ref>;</highlight></codeline>
<codeline lineno="38"><highlight class="normal"><sp /><sp /><sp /><sp />ptrCommonCxt-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1a26f741c17c454d43f6a07dbf87d8154e">tunerSt</ref><sp />=<sp />(uint8_t)<ref kindref="member" refid="group__group__capsense__enums_1ggaadb1f5ee70c7d52a5375cdae765093dca90d0945b863d6c568c124179622abcb8">CY_CAPSENSE_TU_FSM_RUNNING</ref>;</highlight></codeline>
<codeline lineno="39"><highlight class="normal">}</highlight></codeline>
<codeline lineno="40"><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal" /></codeline>
<codeline lineno="42"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="43"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_CapSense_RunTuner</highlight></codeline>
<codeline lineno="44"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="137"><highlight class="normal">uint32_t<sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga0c613df550388c119fdab4e50341a6b4">Cy_CapSense_RunTuner</ref>(<ref kindref="compound" refid="structcy__stc__capsense__context__t">cy_stc_capsense_context_t</ref><sp />*<sp />context)</highlight></codeline>
<codeline lineno="138"><highlight class="normal">{</highlight></codeline>
<codeline lineno="139"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />interruptState;</highlight></codeline>
<codeline lineno="140"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />updateFlag<sp />=<sp />0uL;</highlight></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />tunerStatus<sp />=<sp /><ref kindref="member" refid="group__group__capsense__macros__miscellaneous_1ga14217247882e150c2ac54b09ad64e4d9">CY_CAPSENSE_STATUS_RESTART_NONE</ref>;</highlight></codeline>
<codeline lineno="142"><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />tunerCommand;</highlight></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />cmdOffset;</highlight></codeline>
<codeline lineno="144"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />cmdSize;</highlight></codeline>
<codeline lineno="145"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />cmdCounter;</highlight></codeline>
<codeline lineno="146"><highlight class="normal" /></codeline>
<codeline lineno="147"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />*<sp />tunerStructure<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="148"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />*<sp />commandPacket<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="149"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">volatile</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__capsense__common__context__t">cy_stc_capsense_common_context_t</ref><sp />*<sp />ptrCommonCxt<sp />=<sp />context-&gt;<ref kindref="member" refid="structcy__stc__capsense__context__t_1a2f4f7d25d0816cf7fe6f04103c4d647e">ptrCommonContext</ref>;</highlight></codeline>
<codeline lineno="150"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />tunerState<sp />=<sp />ptrCommonCxt-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1a26f741c17c454d43f6a07dbf87d8154e">tunerSt</ref>;</highlight></codeline>
<codeline lineno="151"><highlight class="normal" /></codeline>
<codeline lineno="152"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__capsense__structures_1gabf58e6ce283cb73f9b8a398abf6bad17">cy_capsense_tuner_send_callback_t</ref><sp />sendCallback<sp />=<sp />context-&gt;<ref kindref="member" refid="structcy__stc__capsense__context__t_1a2f4f7d25d0816cf7fe6f04103c4d647e">ptrCommonContext</ref>-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1ae0c310162f4df691e7d5ac8ec7937491">ptrTunerSendCallback</ref>;</highlight></codeline>
<codeline lineno="153"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__capsense__structures_1gade1f00c852892b0fc498c9a3b9d28594">cy_capsense_tuner_receive_callback_t</ref><sp />receiveCallback<sp />=<sp />context-&gt;<ref kindref="member" refid="structcy__stc__capsense__context__t_1a2f4f7d25d0816cf7fe6f04103c4d647e">ptrCommonContext</ref>-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1a18d43c62af42453bbd7a41778691a7e2">ptrTunerReceiveCallback</ref>;</highlight></codeline>
<codeline lineno="154"><highlight class="normal" /></codeline>
<codeline lineno="155"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">do</highlight><highlight class="normal" /></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="157"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp /></highlight></codeline>
<codeline lineno="158"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />ONE_SCAN<sp />command<sp />could<sp />be<sp />interpreted<sp />as<sp />two<sp />commands:</highlight></codeline>
<codeline lineno="159"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />RESUME<sp />till<sp />next<sp />call<sp />of<sp />this<sp />function<sp />and<sp />then</highlight></codeline>
<codeline lineno="160"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />SUSPEND<sp />till<sp />next<sp />command<sp />receiving.</highlight></codeline>
<codeline lineno="161"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />So,<sp />after<sp />one<sp />scan<sp />cycle<sp />tuner<sp />state<sp />is<sp />changed<sp />to<sp />suspend.</highlight></codeline>
<codeline lineno="162"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((uint8_t)<ref kindref="member" refid="group__group__capsense__enums_1ggaadb1f5ee70c7d52a5375cdae765093dca8bfd4b992045ded35c5a92a3fd1de30a">CY_CAPSENSE_TU_FSM_ONE_SCAN</ref><sp />==<sp />tunerState)</highlight></codeline>
<codeline lineno="164"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />interruptState<sp />=<sp />Cy_SysLib_EnterCriticalSection();</highlight></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />context-&gt;<ref kindref="member" refid="structcy__stc__capsense__context__t_1a2f4f7d25d0816cf7fe6f04103c4d647e">ptrCommonContext</ref>-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1afae9853b830d6549b35bafc214acc040">tunerCmd</ref><sp />=<sp />(uint16_t)<ref kindref="member" refid="group__group__capsense__enums_1gga049118d05a2bdf4f2d37d7b75c511f79a86106715ac1df2c1149a7c9dedb51469">CY_CAPSENSE_TU_CMD_SUSPEND_E</ref>;</highlight></codeline>
<codeline lineno="167"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SysLib_ExitCriticalSection(interruptState);</highlight></codeline>
<codeline lineno="168"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="169"><highlight class="normal" /></codeline>
<codeline lineno="170"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Send<sp />Data<sp />to<sp />the<sp />CapSense<sp />Tuner<sp />tool<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="171"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(NULL<sp />!=<sp />sendCallback)</highlight></codeline>
<codeline lineno="172"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="173"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />sendCallback((</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*)context);</highlight></codeline>
<codeline lineno="174"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="175"><highlight class="normal" /></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Command<sp />can<sp />come<sp />from<sp />EzI2C<sp />by<sp />direct<sp />writing<sp />into<sp />data<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerCommand<sp />=<sp />context-&gt;<ref kindref="member" refid="structcy__stc__capsense__context__t_1a2f4f7d25d0816cf7fe6f04103c4d647e">ptrCommonContext</ref>-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1afae9853b830d6549b35bafc214acc040">tunerCmd</ref>;</highlight></codeline>
<codeline lineno="178"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdCounter<sp />=<sp />context-&gt;<ref kindref="member" refid="structcy__stc__capsense__context__t_1a2f4f7d25d0816cf7fe6f04103c4d647e">ptrCommonContext</ref>-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1ac6502f0565b37d6ba97cce1c81a773b3">tunerCnt</ref><sp />+<sp />1u;</highlight></codeline>
<codeline lineno="179"><highlight class="normal" /></codeline>
<codeline lineno="180"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Call<sp />user's<sp />callback<sp />function<sp />if<sp />it<sp />is<sp />registered<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(NULL<sp />!=<sp />receiveCallback)</highlight></codeline>
<codeline lineno="182"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="183"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />commandPacket<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="184"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerStructure<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />receiveCallback(&amp;commandPacket,<sp />&amp;tunerStructure,<sp />context);</highlight></codeline>
<codeline lineno="186"><highlight class="normal" /></codeline>
<codeline lineno="187"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />command<sp />exists<sp />and<sp />is<sp />correct<sp />then<sp />read<sp />command<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((NULL<sp />!=<sp />commandPacket)<sp />&amp;&amp;<sp />(NULL<sp />!=<sp />tunerStructure))</highlight></codeline>
<codeline lineno="189"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="190"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_CAPSENSE_COMMAND_OK<sp />==<sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga1f0fdedcec1ad936f5e9e4ae28f17274">Cy_CapSense_CheckTunerCmdIntegrity</ref>(commandPacket))</highlight></codeline>
<codeline lineno="191"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="192"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerCommand<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_CODE_0_IDX];</highlight></codeline>
<codeline lineno="193"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ptrCommonCxt-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1afae9853b830d6549b35bafc214acc040">tunerCmd</ref><sp />=<sp />tunerCommand;</highlight></codeline>
<codeline lineno="194"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdCounter<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_CNTR_0_IDX];</highlight></codeline>
<codeline lineno="195"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="196"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="197"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="198"><highlight class="normal" /></codeline>
<codeline lineno="199"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />command<sp />register<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="200"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(tunerCommand)</highlight></codeline>
<codeline lineno="201"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="202"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />(uint16_t)<ref kindref="member" refid="group__group__capsense__enums_1gga049118d05a2bdf4f2d37d7b75c511f79a86106715ac1df2c1149a7c9dedb51469">CY_CAPSENSE_TU_CMD_SUSPEND_E</ref>:</highlight></codeline>
<codeline lineno="203"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerState<sp />=<sp />(uint8_t)<ref kindref="member" refid="group__group__capsense__enums_1ggaadb1f5ee70c7d52a5375cdae765093dcabd652b762757d2927ff7efc5b61d58ea">CY_CAPSENSE_TU_FSM_SUSPENDED</ref>;</highlight></codeline>
<codeline lineno="204"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />updateFlag<sp />=<sp />1u;</highlight></codeline>
<codeline lineno="205"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="206"><highlight class="normal" /></codeline>
<codeline lineno="207"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />(uint16_t)<ref kindref="member" refid="group__group__capsense__enums_1gga049118d05a2bdf4f2d37d7b75c511f79ae9746952315a1ef0fc8e294383b37e0f">CY_CAPSENSE_TU_CMD_RESUME_E</ref>:</highlight></codeline>
<codeline lineno="208"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerState<sp />=<sp />(uint8_t)<ref kindref="member" refid="group__group__capsense__enums_1ggaadb1f5ee70c7d52a5375cdae765093dca90d0945b863d6c568c124179622abcb8">CY_CAPSENSE_TU_FSM_RUNNING</ref>;</highlight></codeline>
<codeline lineno="209"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />updateFlag<sp />=<sp />1u;</highlight></codeline>
<codeline lineno="210"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="211"><highlight class="normal" /></codeline>
<codeline lineno="212"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />(uint16_t)<ref kindref="member" refid="group__group__capsense__enums_1gga049118d05a2bdf4f2d37d7b75c511f79ab9eb1fff3c78f2eb26b9a33c667e5385">CY_CAPSENSE_TU_CMD_RESTART_E</ref>:</highlight></codeline>
<codeline lineno="213"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__capsense__high__level_1gade28f1f915ce6b97f13399074a819c0d">Cy_CapSense_Enable</ref>(context);</highlight></codeline>
<codeline lineno="214"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerStatus<sp />=<sp /><ref kindref="member" refid="group__group__capsense__macros__miscellaneous_1ga58ba0a06e4c9655932c533924e6e7a1c">CY_CAPSENSE_STATUS_RESTART_DONE</ref>;</highlight></codeline>
<codeline lineno="215"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerState<sp />=<sp />(uint8_t)<ref kindref="member" refid="group__group__capsense__enums_1ggaadb1f5ee70c7d52a5375cdae765093dca90d0945b863d6c568c124179622abcb8">CY_CAPSENSE_TU_FSM_RUNNING</ref>;</highlight></codeline>
<codeline lineno="216"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />updateFlag<sp />=<sp />1u;</highlight></codeline>
<codeline lineno="217"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="218"><highlight class="normal" /></codeline>
<codeline lineno="219"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />(uint16_t)<ref kindref="member" refid="group__group__capsense__enums_1gga049118d05a2bdf4f2d37d7b75c511f79a133f8c8b5cdf8f35e298d8cd203d17c5">CY_CAPSENSE_TU_CMD_PING_E</ref>:</highlight></codeline>
<codeline lineno="220"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerState<sp />=<sp />(uint8_t)<ref kindref="member" refid="group__group__capsense__enums_1ggaadb1f5ee70c7d52a5375cdae765093dca90d0945b863d6c568c124179622abcb8">CY_CAPSENSE_TU_FSM_RUNNING</ref>;</highlight></codeline>
<codeline lineno="221"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />updateFlag<sp />=<sp />1u;</highlight></codeline>
<codeline lineno="222"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="223"><highlight class="normal" /></codeline>
<codeline lineno="224"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />(uint16_t)<ref kindref="member" refid="group__group__capsense__enums_1gga049118d05a2bdf4f2d37d7b75c511f79a4878ec99a8b651b4a1812af156b4df6d">CY_CAPSENSE_TU_CMD_ONE_SCAN_E</ref>:</highlight></codeline>
<codeline lineno="225"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerState<sp />=<sp />(uint8_t)<ref kindref="member" refid="group__group__capsense__enums_1ggaadb1f5ee70c7d52a5375cdae765093dca8bfd4b992045ded35c5a92a3fd1de30a">CY_CAPSENSE_TU_FSM_ONE_SCAN</ref>;</highlight></codeline>
<codeline lineno="226"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />updateFlag<sp />=<sp />0u;</highlight></codeline>
<codeline lineno="227"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="228"><highlight class="normal" /></codeline>
<codeline lineno="229"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp />(uint16_t)<ref kindref="member" refid="group__group__capsense__enums_1gga049118d05a2bdf4f2d37d7b75c511f79a0598ab56c52f94b05400c1c4b52243b9">CY_CAPSENSE_TU_CMD_WRITE_E</ref>:</highlight></codeline>
<codeline lineno="230"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">((NULL<sp />!=<sp />receiveCallback)<sp />&amp;&amp;<sp />(NULL<sp />!=<sp />commandPacket)<sp />&amp;&amp;<sp />(NULL<sp />!=<sp />tunerStructure))</highlight></codeline>
<codeline lineno="231"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="232"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Tuner<sp />state<sp />is<sp />not<sp />changed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="233"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdOffset<sp />=<sp />(uint32_t)((uint32_t)commandPacket[CY_CAPSENSE_COMMAND_OFFS_0_IDX]<sp />&lt;&lt;<sp />CY_CAPSENSE_MSB_SHIFT)<sp />|</highlight></codeline>
<codeline lineno="234"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint32_t)commandPacket[CY_CAPSENSE_COMMAND_OFFS_1_IDX];</highlight></codeline>
<codeline lineno="235"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdSize<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_SIZE_0_IDX];</highlight></codeline>
<codeline lineno="236"><highlight class="normal" /></codeline>
<codeline lineno="237"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(1u<sp />==<sp />cmdSize)</highlight></codeline>
<codeline lineno="238"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="239"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerStructure[cmdOffset]<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_DATA_0_IDX<sp />+<sp />3u];</highlight></codeline>
<codeline lineno="240"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="241"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(2u<sp />==<sp />cmdSize)</highlight></codeline>
<codeline lineno="242"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="243"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerStructure[cmdOffset<sp />+<sp />1u]<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_DATA_0_IDX<sp />+<sp />2u];</highlight></codeline>
<codeline lineno="244"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerStructure[cmdOffset<sp />+<sp />0u]<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_DATA_0_IDX<sp />+<sp />3u];</highlight></codeline>
<codeline lineno="245"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="246"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="247"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="248"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerStructure[cmdOffset<sp />+<sp />3u]<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_DATA_0_IDX<sp />+<sp />0u];</highlight></codeline>
<codeline lineno="249"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerStructure[cmdOffset<sp />+<sp />2u]<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_DATA_0_IDX<sp />+<sp />1u];</highlight></codeline>
<codeline lineno="250"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerStructure[cmdOffset<sp />+<sp />1u]<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_DATA_0_IDX<sp />+<sp />2u];</highlight></codeline>
<codeline lineno="251"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tunerStructure[cmdOffset<sp />+<sp />0u]<sp />=<sp />commandPacket[CY_CAPSENSE_COMMAND_DATA_0_IDX<sp />+<sp />3u];</highlight></codeline>
<codeline lineno="252"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="253"><highlight class="normal" /></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />updateFlag<sp />=<sp />1u;</highlight></codeline>
<codeline lineno="255"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="256"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="257"><highlight class="normal" /></codeline>
<codeline lineno="258"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">default</highlight><highlight class="normal">:</highlight></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="260"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="261"><highlight class="normal" /></codeline>
<codeline lineno="262"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ptrCommonCxt-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1a26f741c17c454d43f6a07dbf87d8154e">tunerSt</ref><sp />=<sp />tunerState;</highlight></codeline>
<codeline lineno="263"><highlight class="normal" /></codeline>
<codeline lineno="264"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />Complete<sp />flag<sp />in<sp />command<sp />register<sp />if<sp />needed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="265"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0uL<sp />!=<sp />updateFlag)</highlight></codeline>
<codeline lineno="266"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="267"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />interruptState<sp />=<sp />Cy_SysLib_EnterCriticalSection();</highlight></codeline>
<codeline lineno="268"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />that<sp />command<sp />wasn't<sp />overwritten<sp />with<sp />new<sp />command<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="269"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(tunerCommand<sp />==<sp />ptrCommonCxt-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1afae9853b830d6549b35bafc214acc040">tunerCmd</ref>)</highlight></codeline>
<codeline lineno="270"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="271"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ptrCommonCxt-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1afae9853b830d6549b35bafc214acc040">tunerCmd</ref><sp />|=<sp /><ref kindref="member" refid="group__group__capsense__macros__miscellaneous_1ga28d833476c3b7b4c16772b4271f50ff4">CY_CAPSENSE_TU_CMD_COMPLETE_BIT</ref>;</highlight></codeline>
<codeline lineno="272"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ptrCommonCxt-&gt;<ref kindref="member" refid="structcy__stc__capsense__common__context__t_1ac6502f0565b37d6ba97cce1c81a773b3">tunerCnt</ref><sp />=<sp />cmdCounter;</highlight></codeline>
<codeline lineno="273"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="274"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SysLib_ExitCriticalSection(interruptState);</highlight></codeline>
<codeline lineno="275"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />updateFlag<sp />=<sp />0uL;</highlight></codeline>
<codeline lineno="276"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="277"><highlight class="normal" /></codeline>
<codeline lineno="278"><highlight class="normal"><sp /><sp /><sp /><sp />}<sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />((uint8_t)<ref kindref="member" refid="group__group__capsense__enums_1ggaadb1f5ee70c7d52a5375cdae765093dcabd652b762757d2927ff7efc5b61d58ea">CY_CAPSENSE_TU_FSM_SUSPENDED</ref><sp />==<sp />tunerState);</highlight></codeline>
<codeline lineno="279"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="280"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />tunerStatus;</highlight></codeline>
<codeline lineno="281"><highlight class="normal">}</highlight></codeline>
<codeline lineno="282"><highlight class="normal" /></codeline>
<codeline lineno="283"><highlight class="normal" /></codeline>
<codeline lineno="284"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="285"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_CapSense_CheckTunerCmdIntegrity</highlight></codeline>
<codeline lineno="286"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="329"><highlight class="normal">uint32_t<sp /><ref kindref="member" refid="group__group__capsense__high__level_1ga1f0fdedcec1ad936f5e9e4ae28f17274">Cy_CapSense_CheckTunerCmdIntegrity</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp />*<sp />commandPacket)</highlight></codeline>
<codeline lineno="330"><highlight class="normal">{</highlight></codeline>
<codeline lineno="331"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />cmdCheckStatus<sp />=<sp />CY_CAPSENSE_COMMAND_OK;</highlight></codeline>
<codeline lineno="332"><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />crcValue;</highlight></codeline>
<codeline lineno="333"><highlight class="normal" /></codeline>
<codeline lineno="334"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_CAPSENSE_COMMAND_HEAD_0<sp />!=<sp />commandPacket[CY_CAPSENSE_COMMAND_HEAD_0_IDX])</highlight></codeline>
<codeline lineno="335"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="336"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdCheckStatus<sp />=<sp />CY_CAPSENSE_WRONG_HEADER;</highlight></codeline>
<codeline lineno="337"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="338"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_CAPSENSE_COMMAND_HEAD_1<sp />!=<sp />commandPacket[CY_CAPSENSE_COMMAND_HEAD_1_IDX])</highlight></codeline>
<codeline lineno="339"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="340"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdCheckStatus<sp />=<sp />CY_CAPSENSE_WRONG_HEADER;</highlight></codeline>
<codeline lineno="341"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="342"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_CAPSENSE_COMMAND_TAIL_0<sp />!=<sp />commandPacket[CY_CAPSENSE_COMMAND_TAIL_0_IDX])</highlight></codeline>
<codeline lineno="343"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="344"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdCheckStatus<sp />=<sp />CY_CAPSENSE_WRONG_TAIL;</highlight></codeline>
<codeline lineno="345"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="346"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_CAPSENSE_COMMAND_TAIL_1<sp />!=<sp />commandPacket[CY_CAPSENSE_COMMAND_TAIL_1_IDX])</highlight></codeline>
<codeline lineno="347"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="348"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdCheckStatus<sp />=<sp />CY_CAPSENSE_WRONG_TAIL;</highlight></codeline>
<codeline lineno="349"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="350"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_CAPSENSE_COMMAND_TAIL_2<sp />!=<sp />commandPacket[CY_CAPSENSE_COMMAND_TAIL_2_IDX])</highlight></codeline>
<codeline lineno="351"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="352"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdCheckStatus<sp />=<sp />CY_CAPSENSE_WRONG_TAIL;</highlight></codeline>
<codeline lineno="353"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="354"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(((uint8_t)<ref kindref="member" refid="group__group__capsense__enums_1gga049118d05a2bdf4f2d37d7b75c511f79a0598ab56c52f94b05400c1c4b52243b9">CY_CAPSENSE_TU_CMD_WRITE_E</ref>)<sp />&lt;<sp />commandPacket[CY_CAPSENSE_COMMAND_CODE_0_IDX])</highlight></codeline>
<codeline lineno="355"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="356"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdCheckStatus<sp />=<sp />CY_CAPSENSE_WRONG_CODE;</highlight></codeline>
<codeline lineno="357"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="358"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="359"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="360"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />crcValue<sp />=<sp />(uint16_t)((uint16_t)commandPacket[CY_CAPSENSE_COMMAND_CRC_0_IDX]<sp />&lt;&lt;<sp />CY_CAPSENSE_MSB_SHIFT);</highlight></codeline>
<codeline lineno="361"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />crcValue<sp />|=<sp />(uint16_t)commandPacket[CY_CAPSENSE_COMMAND_CRC_1_IDX];</highlight></codeline>
<codeline lineno="362"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(crcValue<sp />!=<sp /><ref kindref="member" refid="group__group__capsense__low__level_1ga2de812825cd421ee05fec733206e157a">Cy_CapSense_GetCRC</ref>(&amp;commandPacket[0u],<sp />CY_CAPSENSE_COMMAND_CRC_DATA_SIZE))</highlight></codeline>
<codeline lineno="363"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="364"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cmdCheckStatus<sp />=<sp />CY_CAPSENSE_WRONG_CRC;</highlight></codeline>
<codeline lineno="365"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="366"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="367"><highlight class="normal" /></codeline>
<codeline lineno="368"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />cmdCheckStatus;</highlight></codeline>
<codeline lineno="369"><highlight class="normal">}</highlight></codeline>
<codeline lineno="370"><highlight class="normal" /></codeline>
<codeline lineno="371"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />(defined(CY_IP_MXCSDV2)<sp />||<sp />defined(CY_IP_M0S8CSDV2)<sp />||<sp />defined(CY_IP_M0S8MSCV3))<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="372"><highlight class="normal" /></codeline>
<codeline lineno="373"><highlight class="normal" /></codeline>
<codeline lineno="374"><highlight class="normal" /><highlight class="comment">/*<sp />[]<sp />END<sp />OF<sp />FILE<sp />*/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-capsense/cy_capsense_tuner.c" />
  </compounddef>
</doxygen>